var Element = function () {
    var id = undefined;

    Object.defineProperties(this, {
        id: {
            get: function () { return id; },
            set: function (value) { id = value; }
        },
    });
};

Element.prototype = new Object();
Element.prototype.constructor = Element;

var MouseEvent = function () {

};

MouseEvent.prototype = new MouseEvent();
MouseEvent.prototype.constructor = MouseEvent;

var GlobalEventHandlers = function (self) {
    var events = {
        // Contains the event registry itself.
    };

    var addEvent = function (r) {
        Object.defineProperty(self, "on" + r, {
            enumerable: true,
            configurable: false,
            get: function () {
                return events[r];
            },
            set: function (value) {
                events[r] = value;
            },
        });
    }

    var names = [
        "mouseover",
        "mousemove",
        "mouseout",
        "mousedown",
        "mouseup",
        "click",
    ];

    for (var i in names) {
        addEvent(names[i]);
    };

    self._dispatchEvent = function (e) {
        var event = events[e.type];

        if (event) {
            event(e);
        }
    }
};

var HTMLElement = function () {
    GlobalEventHandlers(this);
};

HTMLElement.prototype = new Element();
HTMLElement.prototype.constructor = HTMLElement;
