var Entity = {
    create: function (runtime, type, name) {
        var self = {
            id: runtime.bridge.CreateEntity(type),
            type: type,
            name: name
        };

        if (name) {
            runtime.bridge.SetEntityName(self, name);
        }

        self.components = ComponentCollection.create(runtime, self);

        runtime.entities[name] = self;
        runtime.entitiesById[self.id] = self;

        return self;
    },
    get: function (runtime, name, type) {
        var self = {
            id: runtime.bridge.GetEntity(name),
            type: type,
            name: name
        };

        self.components = ComponentCollection.create(runtime, self);

        runtime.entitiesById[self.id] = self;

        return self;
    },
    wrap: function (runtime, id) {
        var self = {
            id: id,
        };

        self.components = ComponentCollection.create(runtime, self);

        runtime.entitiesById[self.id] = self;

        return self;
    }
};
