float4 equal(float4 a, float4 b)
{
  return float4(a.x == b.x, a.y == b.y, a.z == b.z, a.w == b.w);
}

float3 snapAdaptivePlanarGridEdges(float3 pos)
{
  if (pos.z != 0.0) {
    float l = dot(float4(equal(float4(floor(pos.z), floor(pos.z), floor(pos.z) ,floor(pos.z)), float4(1, 2, 3, 4))),
                  float4(lodLevels));

    float s = exp2(l);

    pos.xy = (1.0 / s) * floor(s * pos.xy + frac(pos.zz));
    pos.z = 0.0;
  }

  return pos;
}

float2 getTexCoordWorld(float2 v)
{
  float2 z = texCoordWorldTransform.xy*v;

  float4 m = texCoordLinearTransform;
  float2 q = float2(m.x*z.x + m.z*z.y,
                    m.y*z.x + m.w*z.y);

  return q + texCoordWorldTransform.zw;
}

float2 getTexCoordUnit(float2 v)
{
  float2 z = texCoordUnitTransform.xy*v;

    float4 m = texCoordLinearTransform;
    float2 q = float2(m.x*z.x + m.z*z.y,
    m.y*z.x + m.w*z.y);

  return q + texCoordUnitTransform.zw;
}
