VertexOut vertexFunction(VertexIn In)
{
  VertexOut Out = createVertexOut();

  vec3 position = mat3(viewMatrix) * (mat3(worldMatrix) * In.Position.xyz); //compute position without translation

  float f = 2.0; //far plane dist
  float n = 0.1; //near plane dist

  float A = -(f + n) / (f - n);
  float B = -(2.0 * f * n) / (f - n);

  mat4 modifiedProjection = projectionMatrix;

  if (abs(projectionMatrix[2][3]) < 0.000001) { //orthographic camera check
    float a = projectionMatrix[0][0]/projectionMatrix[1][1]; // find view aspect ratio
    float e = (2.0 * 30.0) / 24.0;

    modifiedProjection = mat4(e*a, 0.0, 0.0, 0.0,
                              0.0, e,   0.0, 0.0,
                              0.0, 0.0, A,  -1.0,
                              0.0, 0.0, B,   0.0);
  } else {
    modifiedProjection[0][2] = 0.0;
    modifiedProjection[1][2] = 0.0;
    modifiedProjection[2][2] = A;
    modifiedProjection[3][2] = B;
  }

  Out.Position = modifiedProjection * vec4(position, 1);
  Out.Direction = vec4(In.Position.xyz, 0);
  Out.TexCoord = In.TexCoord;

  return Out;
}
