VertexOut vertexFunction(in VertexIn vertexIn)
{
  VertexOut vertexOut;

  vec4 cp = worldToClipMatrix*(worldMatrix*vec4(vertexIn.Position.xyz, 1.0));
  float scale = 1.0 / cp.w;
  vec3 p = scale * cp.xyz;

  vec2 corner = vec2(vertexIn.Position.w < 0.0 ? 1 : 0, abs(vertexIn.Position.w) < 2.0 ? 1 : 0) - vec2(0.5, 0.5);
  vertexOut.texCoord = pointSizes().x * corner;

  float scaledPointSize = clamp(scale * pointSizes().x, pointSizeClamp().x, pointSizeClamp().y);
  p.xy = floor(viewportScale().xy * p.xy) + vec2(0.5, 0.5) + scaledPointSize * corner;

  vertexOut.Position = vec4(viewportScale().zw * p.xy, p.z, 1.0);

  return vertexOut;
}
