
#include "SpriteCommon.es20.glsl"

VertexOut vertexFunction(VertexIn In)
{
  VertexOut Out = createVertexOut();

  vec4 inPosition = positionTypeAsFloat4(In.Position);

  vec4 VsPosition;

#if defined (COGS_SPRITES_VIEWTRANSFORM)
  Out.WorldPosition = worldMatrix * vec4(inPosition.xyz,1);
  VsPosition = worldToClipMatrix * Out.WorldPosition;
#elif defined (COGS_SPRITES_PIXELTRANSFORM)
  vec2 viewportScale = 1.0 / viewport.zw;
  vec2 scaled = inPosition.xy * viewportScale;
  vec2 ndc = vec2(scaled.x, scaled.y) * 2.0 - vec2(1, 1);
#ifdef COGS_REVERSE_DEPTH
  inPosition.z = -inPosition.z;
#endif
  VsPosition = vec4(ndc, inPosition.z*0.5+0.5, 1);
#else
#ifdef COGS_REVERSE_DEPTH
  inPosition.z = -inPosition.z;
#endif
  VsPosition = worldMatrix * vec4(inPosition.xy, inPosition.z*0.5+0.5, 1);
#endif

  vec4 VsTexCoord;
  VsTexCoord.xz = imageFlip().x * (vec2(1) - In.TexCoord.xz) + (vec2(1) - imageFlip().x) * In.TexCoord.xz;
  VsTexCoord.yw = imageFlip().y * (vec2(1) - In.TexCoord.yw) + (vec2(1) - imageFlip().y) * In.TexCoord.yw;

  float index = inPosition.w;
  if (VsPosition.z < -VsPosition.w) index = 0.0;

  Out.TexCoord.zw = vec2(0);
  quadExpand(Out.Position,
             Out.Weights,
             Out.TexCoord.xy,
             VsPosition,
             In.Normal,
             VsTexCoord,
             index);

  return Out;
}
