VertexOut vertexFunction(VertexIn In)
{
  VertexOut Out = (VertexOut) 0;

  float radius = In.Normal.z;
  float scale = In.Normal.x - radius;
  float textureScale = In.Normal.y;
  
  float3 direction = In.Tangent;
  
  Out.TexCoord = float2(textureScale, 0);
  
  float4 worldPosition = mul(positionTypeAsFloat4(In.Position), worldMatrix);
  float4 worldAxis = mul(float4(axis.xyz, 0), inverseViewMatrix);
  
  float3 forward = cross(worldAxis.xyz, -direction);
  float3 right = normalize(cross(-direction, forward));
  
  worldPosition += (radius * float4(right.xyz, 0)) + (scale * float4(worldAxis.xyz, 0));
  
  float4 viewPosition = mul(worldPosition, viewMatrix);
  
  Out.Position = mul(viewPosition, projectionMatrix);

  return Out;
}
